#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import <PGPserver.h>
#import <pgp.h>
#import "MiscINETAddress.h"
#import "MiscINETSocket.h"

@interface PGPfrontEnd:NSObject
{
    PGPserver *cryptor;
    NSArray *keyRingArray;

    /* Outlets */
    id selectKeyPanel;
    id userIDTableView;
    id optionButtons;

    id passphrasePanel;
    id passphraseText;

    id decryptInfoPanel;
    id decryptFileTextField;
    id encryptInfoPanel;
    id encryptFileTextField;
    id statusPanel,statusTextView;
    id outputPanel,outputTextView;
}

- init;
- (void)dealloc;

- (NSString *)getPBString:(NSPasteboard *)pboard;
- (NSMutableData *)getPBStringData:(NSPasteboard *)pboard;
- (NSArray *)getPBFileNames:(NSPasteboard *)pboard;

- encrypt:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;

- decrypt:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;
- decryptInWindow:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;

- encryptFiles:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;
- decryptFiles:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;

- clearSign:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;
- detachedSig:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;
- checkSig:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;

- addKey:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;
- addKeyFile:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;
- insertKey:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;

- showStatus:sender;
- showOutput:sender;

- acceptUserID:sender;
- cancelUserID:sender;

- acceptPassphrase:sender;
- cancelPassphrase:sender;

- (void)getKeyFromServer:(NSPasteboard *)pboard userData:(NSString *)inData error:(NSString **)error;
- (NSString *)getKey:(NSString *)userID fromServer:(NSString *)pgpKeyServer error:(int *)errorCode;

@end


